#ifndef _canvas_mt_connect_h_
#define _canvas_mt_connect_h_

#include "MouseTool.h"
#include "connector.h"

namespace cv {

	//##ModelId=4D6056330138
	class MTConnect : public MouseTool 
	{
  public:

		//##ModelId=4D6056330139
		enum connectState { idle, wiringTail, leavingTail, wiringHead};

		//##ModelId=4D60563302F0
		MTConnect(Diagram* c);

    //##ModelId=4D64356A000F
		void startWiring(Connector* c);

		

		//##ModelId=4D60563302F4
		bool notify(Event* evt);

		// event
    // Destroy the connector if wiring didn't finished well
    // (one side was wrong)
    //##ModelId=4D64360A008C
    void abort();

		// event
    // Let the connector survive even if its is free at one side
    //##ModelId=4D613690005D
		void finished();
    //##ModelId=4D76EC5500EA
    void linkToTheNull();



		//##ModelId=4D60563302E7
		connectState state;
		//##ModelId=4D60563302EC
		Connector* connector;

	private:


    //##ModelId=4D64356903D9
		Canvas* event_target;
    //##ModelId=4D64356A0001
		Point event_point;

    //##ModelId=4D64356A002E
		void enterState(connectState newState);

    //##ModelId=4D64356A001F
		bool validTarget();


	};
}
#endif
