#ifndef PROXY_H_HEADER_INCLUDED_B288C48A
#define PROXY_H_HEADER_INCLUDED_B288C48A
#include "Handler.h"
#include "Command.h"

namespace gm {

// Delegates messages ot its delegate.
// One player can control more than one canvas using proxies
//##ModelId=4D77142C0138
class Proxy : public Handler
{
  public:
    //##ModelId=4D7715610128
    Proxy(Handler* _delegate);
    //##ModelId=4D7715CD034B
    bool canConnectTo(Handler* head, Handler* connector);


    //##ModelId=4D7715D600DA
    bool canConnectFrom(Handler* tail);

  
    //##ModelId=4D7715DB004E
    bool canOwn(Handler* m);

  
    // protocol: command
    //##ModelId=4D7715E1008C
    bool canPerform(Command* cmd);

  
    // protocol: command
    //##ModelId=4D7715F601B5
    void perform(Command* cmd);
    //##ModelId=4D77175F03D8
    //Handler::ModelType get_type();
    //##ModelId=4D7719F30290
    Handler::CommandVector& get_commands();



  private:
    //##ModelId=4D7715550271
    Handler* delegate;

};

} // namespace gm



#endif /* PROXY_H_HEADER_INCLUDED_B288C48A */
