#ifndef CV_EVENT_H
#define CV_EVENT_H


#include "geometry.h"
#include "canvas.h"

//namespace cv { class Canvas; } 

namespace cv {

//##ModelId=4D605633016C
enum eventTag {
  LEFT_DOWN,
  LEFT_DRAG,
  LEFT_UP,
  MOUSE_MOVE,
  KEY_DEL,
  KEY_INS

};
//##ModelId=4D605633016E
enum keyModifiers {
  K_SHIFT =  2
		,
  K_CONTROL =  4
		,
  K_ALT =  8
	

};


/* event class
is a class
 */
//##ModelId=4D605633010A
class Event {
  public:
		//##ModelId=4D631446007E
		Canvas::CanvasVector subjects;

    //##ModelId=4D6056330296
    eventTag tag;

    //##ModelId=4D605633029B
    Point pt;

    //##ModelId=4D60563302A5
    Event(eventTag _tag, Point _p);

    //##ModelId=4D60563302A8
    Event(eventTag _tag, double x, double y);

    //##ModelId=4D60563302AC
    bool isMouseEvent();

    //##ModelId=4D60563302AD
    bool isKeyboardEvent();
    // - a push-button activation
    //##ModelId=4D6D15360186
    bool isCommandEvent();



    //##ModelId=4D60563302A4
    int key_modifiers;

};

} // namespace cv
#endif
